function add_recipe_to_tech(tech_name,recipe_name)
	if data.raw["technology"][tech_name] then
		table.insert(data.raw["technology"][tech_name].effects, {
			type="unlock-recipe",
			recipe=recipe_name
		})
	end
end

function stillpipepictures()
	return {
 		east = {
			filename =
				"__adamo-cinefaction__/graphics/"
				.."connections/washer-pipe-e.png",
			priority = "high",
			width = 256,
			height = 256,
			shift = {-1.74, -0.05},
			scale = 0.5
		},
	 	west = {
			filename =
				"__adamo-cinefaction__/graphics/"
				.."connections/washer-pipe-w.png",
			priority = "high",
			width = 256,
			height = 256,
			shift = {2.26, -0.08},
			scale = 0.5
		},
		north = {
			filename =
				"__adamo-cinefaction__/graphics/"
				.."connections/washer-pipe-n.png",
			priority = "extra-high",
			width = 256,
			height = 256,
			shift = {0.27125, 2},
			scale = 0.5
 		},
		south = {
			filename =
				"__adamo-cinefaction__/graphics/"
				.."connections/washer-pipe-s.png",
			priority = "high",
			width = 256,
			height = 256,
			shift = {0.28125, -2},
			scale = 0.5
		},
	}
end

function kettlepipepictures()
	return {
 		east = {
			filename =
				"__adamo-cinefaction__/graphics/"
				.."connections/washer-pipe-e.png",
			priority = "extra-high",
			width = 256,
			height = 256,
			shift = {-1.71875, 0},
			scale = 0.5
		},
	 	west = {
			filename =
				"__adamo-cinefaction__/graphics/"
				.."connections/washer-pipe-w.png",
			priority = "extra-high",
			width = 256,
			height = 256,
			shift = {2.28125, 0},
			scale = 0.5
		},
		north = {
			filename = 
				"__adamo-cinefaction__/graphics/"
				.."connections/kettle-north.png",
			priority = "extra-high",
			width = 128,
			height = 128,
			scale = 0.5,
		}, 		
		south = {
			filename =
				"__adamo-cinefaction__/graphics/"
				.."connections/clear.png",
			priority = "extra-high",
			width = 32,
			height = 32,
		},
	}
end	

function stillpipecovers()
	return {
		east = {
			filename = 
				"__adamo-cinefaction__/graphics/"
				.."connections/clear.png",
			priority = "extra-high",
			width = 32,
			height = 32,
		},
		west = {
			filename =
				"__adamo-cinefaction__/graphics/"
				.."connections/clear.png",
			priority = "extra-high",
			width = 32,
			height = 32,
		},
		north = {
			filename = 
				"__adamo-cinefaction__/graphics/"
				.."connections/still-north.png",
			priority = "extra-high",
			width = 128,
			height = 128,
			scale = 0.5,
		},
		south = {
			filename =
				"__adamo-cinefaction__/graphics/"
				.."connections/cover-south.png",
			priority = "extra-high",
			width = 128,
			height = 128,
			scale = 0.5,
		},
	}
end

function kettlepipecovers()
	return {
		east = {
			filename = 
				"__adamo-cinefaction__/graphics/"
				.."connections/clear.png",
			priority = "extra-high",
			width = 32,
			height = 32,
		},
		west = {
			filename =
				"__adamo-cinefaction__/graphics/"
				.."connections/clear.png",
			priority = "extra-high",
			width = 32,
			height = 32,
		},
		north = {
			filename =
				"__adamo-cinefaction__/graphics/"
				.."connections/clear.png",
			priority = "extra-high",
			width = 32,
			height = 32,
 		},
		south = {
			filename =
				"__adamo-cinefaction__/graphics/"
				.."connections/cover-south.png",
			priority = "extra-high",
			width = 128,
			height = 128,
			scale = 0.5,
		},
	}
end

local heat_processing_tech = {
	type = "technology",
	name = "adamo-cinefaction-heat-processing",
	icon_size = 128,
	icon = "__adamo-cinefaction__/graphics/heat-processing.png",
	prerequisites = {
		"advanced-material-processing",
		"fluid-handling"
	},
	unit = {
		count = 100,
		ingredients = {{
				"automation-science-pack",
				1
			},{
				"logistic-science-pack",
				1				
		}},
		time = 30
	},
    effects = {{
    		type = "unlock-recipe",
    		recipe = "heat-pipe"
    	},{
    		type = "unlock-recipe",
    		recipe = "heat-exchanger"
    	},{
    		type = "unlock-recipe",
    		recipe = "adamo-cinefaction-heatpump"

    	},{
    		type = "unlock-recipe",
    		recipe = "adamo-cinefaction-reaction-kettle"
	}},
	order = "d-a1"
}
data:extend({
	heat_processing_tech
})

local reaction_kettle_item = {
	type = "item",
	name = "adamo-cinefaction-reaction-kettle",
	icon = "__adamo-cinefaction__/graphics/icons/reaction-kettle.png",
	icon_size = 32,
	group = "production",
	subgroup = "production-machine",
	order = "e[adamo-cinefaction-reaction-kettle]",
	place_result = "adamo-cinefaction-reaction-kettle",
	stack_size = 50
}
local reaction_kettle_recipe = {
	type = "recipe",
	name = "adamo-cinefaction-reaction-kettle",
	enabled = false,
	ingredients = 
	{
		{"copper-plate",2},
		{"steel-plate",2},
		{"stone-brick",2},
		{"pipe",2},
	},
	result = "adamo-cinefaction-reaction-kettle"
}
local reaction_kettle_entity = {
	type = "assembling-machine",
	name = "adamo-cinefaction-reaction-kettle",
	icon = "__adamo-cinefaction__/graphics/icons/reaction-kettle.png",
	icon_size = 32,
	flags = {"placeable-player", "player-creation"},
	crafting_categories = {
		"chemistry",
	},
	result_inventory_size = 0,
	minable = {
		mining_time = 0.2,
		result = "adamo-cinefaction-reaction-kettle"
	},
	max_health = 250,
	crafting_speed = 0.2,
	energy_usage = "20kW",
	corpse = "small-remnants",
	resistances = {{
			type = "fire",
			percent = 80
	}},
	working_sound = {
    	sound = {
    		filename = "__base__/sound/boiler.ogg",
    		volume = 0.8
    	},
    },
	fast_replaceable_group = "pipe",
	collision_box = {{-0.49, -0.49}, {0.49, 0.49}},
	selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
	fluid_boxes = {{
			production_type = "input",
			base_level = -1,
			height = 2,
			pipe_connections = {
				{position={1,0}},
			},
			pipe_picture = kettlepipepictures(),
			pipe_covers = kettlepipecovers()
		},{
			production_type = "input",
			base_level = -1,
			height = 2,
			pipe_connections = {
				{position={-1,0}},
			},
			pipe_picture = kettlepipepictures(),
			pipe_covers = kettlepipecovers()
		},{
			production_type = "output",
			base_level = 1,
			pipe_connections = {
				{position={0,-1}}
			},
			pipe_picture = kettlepipepictures(),
			pipe_covers = kettlepipecovers()
		},{
			production_type = "input",
			base_level = -1,
			height = 2,
			pipe_connections = {
				{position={0,1}}
			},
			pipe_picture = kettlepipepictures(),
			pipe_covers = kettlepipecovers()
		},
		off_when_no_fluid_recipe = true
	},
	energy_source = {
		type = "heat",
		emissions_per_minute = 0.1,
		max_temperature = 300,
		specific_heat = "100kJ",
		max_transfer = "1GW",
		min_working_temperature = 150,
		connections = {{
				position = {0,0},
				direction = defines.direction.north
			},{
				position = {0,0},
				direction = defines.direction.east
			},{
				position = {0,0},
				direction = defines.direction.west
			},{
				position = {0,0},
				direction = defines.direction.south
		}},
		pipe_covers = make_4way_animation_from_spritesheet({
				filename = 
					"__base__/graphics/entity/"
					.."heat-exchanger/heatex-endings.png",
				line_length = 4,
				width = 32,
				height = 32,
				direction_count = 4,
				hr_version = {
					filename = 
						"__base__/graphics/entity/"
						.."heat-exchanger/hr-heatex-endings.png",
					line_length = 4,
					width = 64,
					height = 64,
					direction_count = 4,
					scale = 0.5
				}
		})
	},
	animation = {
		filename =
			"__adamo-cinefaction__/graphics/entity/reaction-kettle.png",
		priority = "extra-high",
		width = 50,
		height = 50,
		--shift = {0.1875, 0.1875}
		shift = {0.24, 0.1875}
	},
}
data:extend({
	reaction_kettle_recipe,
	reaction_kettle_item,
	reaction_kettle_entity
})

local still_item = {
	type = "item",
	name = "adamo-cinefaction-still",
	icon = "__adamo-cinefaction__/graphics/icons/still.png",
	icon_size = 32,
	subgroup = "production-machine",
	order = "d[adamo-cinefaction-still]",
	place_result = "adamo-cinefaction-still",
	stack_size = 10
}
local still_recipe = {
	type = "recipe",
	name = "adamo-cinefaction-still",
	energy_required = 2,
	enabled = false,
	ingredients = {
		{"iron-plate", 5},
		{"pipe", 4},
		{"stone-brick", 5},
		{"electronic-circuit",2}
	},
	result = "adamo-cinefaction-still"
}
local still_entity = {
    type = "assembling-machine",
	name = "adamo-cinefaction-still",
	icon = "__adamo-cinefaction__/graphics/icons/still.png",
	icon_size = 32,
	flags = {
		"placeable-neutral",
		"placeable-player",
		"player-creation"
	},
	minable = {
		hardness = 0.2,
		mining_time = 1.5,
		result = "adamo-cinefaction-still"
	},
	max_health = 450,
	corpse = "medium-remnants",
	resistances = {{type = "fire",percent = 70}},
	collision_box = {{-1.4, -1.4}, {1.4, 1.4}},
	selection_box = {{-1.5, -1.5}, {1.5, 1.5}},	
	crafting_categories = {"oil-processing"},
	energy_usage = "100kW",
	ingredient_count = 0,
	crafting_speed = 0.4,
	energy_source ={
		type = "burner",
		fuel_category = "chemical",
		effectivity = 0.80,
		fuel_inventory_size = 1,
		emissions_per_minute = 2,
		smoke = {{
				name = "smoke",
				height = 1.9,
				deviation = {0.1, 0.1},
				frequency = 7
		}}
	},
	fast_replaceable_group = "assembling-machine",
	module_specification = {
		module_slots = 2
	},
	allowed_effects = {
		"consumption",
		"speed",
		"productivity",
		"pollution"
	},
	fluid_boxes = {{
			production_type = "input",
			pipe_picture = stillpipepictures(),
			pipe_covers = stillpipecovers(),
			base_level = -1,
			pipe_connections = {
				{position={0,-2}},
			},
			secondary_draw_orders = {
				north = -1,
			--	east = 2,
			--	west = -1,
			},
		},{
			production_type = "input",
			pipe_picture = stillpipepictures(),
			pipe_covers = stillpipecovers(),
			base_level = -1,
			pipe_connections = {
				{position={0,-2}},
			},
			secondary_draw_orders = {
				north = -2,
				south = -2,
				east = -2,
				west = -2,
			},
		},{
			production_type = "output",
			pipe_picture = stillpipepictures(),
			pipe_covers = stillpipecovers(),
			base_level = 1,
			pipe_connections = {
				{position={2,0}},
			},
			secondary_draw_orders = {
				north = -1,
			--	east = 2,
			--	west = -1,
			},
		},{
			production_type = "output",
			pipe_picture = stillpipepictures(),
			pipe_covers = stillpipecovers(),
			base_level = 1,
			pipe_connections = {
				{position={0,2}},
			},
			secondary_draw_orders = {
				north = -1,
			--	east = 2,
			--	west = -1,
			},
		},{
			production_type = "output",
			pipe_picture = stillpipepictures(),
			pipe_covers = stillpipecovers(),
			base_level = 1,
			pipe_connections = {
				{position={-2,0}},
			},
			secondary_draw_orders = {
				north = -1,
			--	east = 2,
			--	west = -1,
			},
		},
		off_when_no_fluid_recipe = true
	},
	working_sound = {
		sound = {{
				filename = "__base__/sound/chemical-plant.ogg",
				volume = 0.8
		}},
		idle_sound = {
    		filename = "__base__/sound/idle1.ogg",
    		volume = 0.6
    	},
    	apparent_volume = 1.5,
	},
	animation = {
		filename = "__adamo-cinefaction__/graphics/entity/still.png",
		width = 320, height = 320,
		shift = {0.5, -0.4375}, 
		scale = 0.5,
		frame_count = 16,
		line_length = 4,
		animation_speed = 1.0
	}
}
data:extend({
	still_recipe,
	still_item,
	still_entity
})
add_recipe_to_tech(
	"fluid-handling",
	"adamo-cinefaction-still"
)

local heatpump_item = {
	type = "item",
	name = "adamo-cinefaction-heatpump",
	icon = "__adamo-cinefaction__/graphics/icons/heatpump.png",
	icon_size = 32,
	subgroup = "energy",
	order = "f[heat-energy]-a[adamo-cinefaction-heatpump]",
	place_result = "adamo-cinefaction-heatpump",
	stack_size = 10
}
local heatpump_recipe = {
	type = "recipe",
	name = "adamo-cinefaction-heatpump",
	energy_required = 5,
	enabled = false,
	ingredients = 
	{
		{"copper-plate",10},
		{"steel-plate",20},
		{"electronic-circuit",5},
		{"heat-pipe",5},
	},
	result = "adamo-cinefaction-heatpump"
}

local heatpump_entity = {
	type = "reactor",
	name = "adamo-cinefaction-heatpump",
	icon = "__adamo-cinefaction__/graphics/icons/heatpump.png",
	icon_size = 32,
	flags = {"placeable-neutral", "placeable-player", "player-creation"},
	minable = {mining_time = 2, result = "adamo-cinefaction-heatpump"},
	max_health = 600,
	corpse = "medium-remnants",
	neighbour_bonus = 0,
	neighbour_collision_increase = 0,
	scale_energy_usage = true,
	open_sound = {
		filename = "__base__/sound/machine-open.ogg",
		volume = 0.85
	},
	close_sound = {
		filename = "__base__/sound/machine-close.ogg",
		volume = 0.75
	},
    working_sound ={
		sound = { filename = "__base__/sound/electric-furnace.ogg" }
	},
	resistances = {{
			type = "fire",
			percent = 80
	}},
    collision_box = {{-1.2, -1.2}, {1.2, 1.2}},
	selection_box = {{-1.5, -1.5}, {1.5, 1.5}},	
    consumption = "20MW",
	energy_source = {
		type = "burner",
		fuel_inventory_size = 4,
		burnt_inventory_size = 1,
		smoke = {{
				name = "smoke",
				position = {0,-0.6},
				frequency = 25,
				starting_vertical_speed = 0.08,
				starting_frame_deviation = 60
		}},
		effectivity = 0.8,
		render_no_power_icon = false,
		emissions_per_minute = 30,
	},
	heat_buffer = {
		max_temperature = 300,
		specific_heat = "10MJ",
		max_transfer = "1GW",
		connections = {{
				position = {0, -1},
				direction = defines.direction.north
			},{
				position = {0,0.5},
				direction = defines.direction.south
			},{
				position = {-1, 1},
				direction = defines.direction.west
			},{
				position = {1, 1},
				direction = defines.direction.east
		}}
	},
	picture = {
			filename = 
				"__adamo-cinefaction__/graphics/entity/heatpump.png",
			priority = "extra-high",
			width = 256,
			height = 256,
			shift = {0.3125, -0.15625 },
			scale = 0.5,						
	},
	working_light_picture = {
		filename =
			"__adamo-cinefaction__/graphics/entity/heatpump-S-lights.png",
		width = 256,
		height = 256,
		shift = {0.3125, -0.15625 },
		scale = 0.5,
    },
	connection_patches_connected = {
		sheet = {
			filename =
				"__base__/graphics/entity/nuclear-reactor/"
				.."reactor-connect-patches.png",
			width = 32,
			height = 32,
			variation_count = 12,
			hr_version = {
				filename = 
					"__base__/graphics/entity/nuclear-reactor/"
					.."hr-reactor-connect-patches.png",
				width = 64,
				height = 64,
				variation_count = 12,
				scale = 0.5
			}
		}
	},
	connection_patches_disconnected = {
		sheet = {
			filename = 
				"__base__/graphics/entity/nuclear-reactor/"
				.."reactor-connect-patches.png",
			width = 32,
			height = 32,
			variation_count = 12,
			--y = 32,
			hr_version = {
				filename = 
					"__base__/graphics/entity/nuclear-reactor/"
					.."hr-reactor-connect-patches.png",
				width = 64,
				height = 64,
				variation_count = 12,
				y = 64,
				scale = 0.5
			}
		}
	},
}
data:extend({
	heatpump_recipe,
	heatpump_item,
	heatpump_entity
})



local gas_generator_item =  {
	type = "item",
	name = "adamo-cinefaction-gas-generator",
	icon = "__adamo-cinefaction__/graphics/icons/gas-generator.png",
	icon_size = 32,
	flags = {},
	subgroup = "energy",
	order = "b[steam-power]-d[adamo-cinefaction-gas-generator]",
	place_result = "adamo-cinefaction-gas-generator",
	stack_size = 10
}
local gas_generator_recipe = {
	type = "recipe",
	name = "adamo-cinefaction-gas-generator",
	energy_required = 5,
	category = "crafting-with-fluid",
	enabled = "false",
	ingredients = {
		{"steel-plate", 12},
		{"engine-unit", 10},
		{"electronic-circuit", 16},
		{"pipe", 10},
		{type="fluid",name="lubricant",amount=150}
	},
	result = "adamo-cinefaction-gas-generator"
}
local gas_generator_entity = {
	type = "generator",
	name = "adamo-cinefaction-gas-generator",
	icon = "__adamo-cinefaction__/graphics/icons/gas-generator.png",
	icon_size = 32,
	flags = {"placeable-neutral", "player-creation"},
	minable = {
		mining_time = 2,
		result = "adamo-cinefaction-gas-generator"
	},
	collision_box = {{-0.7, -2.7}, {0.7, 2.7}},
	selection_box = {{-1, -3}, {1, 3}},
	fluid_box = {
		base_area = 1,
		base_level = -1,
		height = 2,
		pipe_covers = pipecoverspictures(),
		production_type = "input-output",
		pipe_connections = {{
				position = {-1.5, 0.5},
				type = "input-output"
			},{
				position = {1.5, 0.5},
				type = "input-output"
		}}
	},
	energy_source = {
		type = "electric",
		usage_priority = "secondary-output",
		emissions_per_minute = 40
	},
	effectivity = 0.8,
	burns_fluid = true,
	scale_fluid_usage = true,
	maximum_temperature = 1000, --not needed...
	fluid_usage_per_tick = 2 / 60,
	max_power_output = (4 / 60) .. "MJ",
	max_health = 300,
	resistances = {{
			type = "fire",
			percent = 70
	}},
	corpse = "big-remnants",
	vehicle_impact_sound = {
		filename = "__base__/sound/car-metal-impact.ogg",
		volume = 0.65
	},
	horizontal_animation = {
		filename = "__adamo-cinefaction__/graphics/entity/gas-generator_h_sheet.png",
		width = 448,
		height = 256,
		frame_count = 8,
		line_length = 4,
		shift = {0.5, -0.40},
		flags = {"no-crop"},
		animation_speed = 0.8,
		scale = 0.5,
		run_mode = "forward-then-backward"
	},
	vertical_animation = {
		filename = "__adamo-cinefaction__/graphics/entity/gas-generator_v_sheet.png",
		width = 256,
		height = 448,
		frame_count = 8,
		line_length = 4,
		shift = {0.8, 0.1},
		flags = {"no-crop"},
		animation_speed = 0.8,
		scale = 0.5
	},
	smoke = {{
			name = "tank-smoke",
			north_position = {0.42, -0.85},
			east_position = {-1.15, -2.0},
			frequency = 10 / 32,
			starting_vertical_speed = 0.06,
			slow_down_factor = 1,
			starting_frame_deviation = 60
		},{
			name = "tank-smoke",
			north_position = {-0.42, -0.85},
			east_position = {-1.15, -1.8},
			frequency = 10 / 32,
			starting_vertical_speed = 0.06,
			slow_down_factor = 1,
			starting_frame_deviation = 60
	}},
	working_sound = {
		sound = {{
				filename = "__adamo-cinefaction__/sounds/diesel-loop-1.ogg",
				volume = 0.5
			},{
				filename = "__adamo-cinefaction__/sounds/diesel-loop-2.ogg",
				volume = 0.5
			},{
				filename = "__adamo-cinefaction__/sounds/diesel-loop-3.ogg",
				volume = 0.5
		}},
		match_speed_to_activity = true,
		max_sounds_per_type = 2
	},
	min_perceived_performance = 0.4,
	performance_to_sound_speedup = 0.2
}
data:extend({
	gas_generator_item,
	gas_generator_recipe,
	gas_generator_entity
})
add_recipe_to_tech(
	"electric-engine",
	"adamo-cinefaction-gas-generator"
)
if not data.raw.boiler["adamo-carbon-gas-fired-boiler"] then
	gf_boiler_entity = util.table.deepcopy(data.raw.boiler.boiler)
	gf_boiler_entity.name = "adamo-cinefaction-gas-fired-boiler"
	gf_boiler_entity.icon = "__adamo-cinefaction__/graphics/icons/gas-fired-boiler.png"
	gf_boiler_entity.icon_size = 32
	gf_boiler_entity.minable.result = "adamo-cinefaction-gas-fired-boiler"
	gf_boiler_entity.energy_source = {
		type = "fluid",
		fluid_box = {
			base_area = 1,
			height = 2,
			base_level = -1,
			pipe_covers = pipecoverspictures(),
			pipe_picture = assembler1pipepictures(),
			pipe_connections = {
				{type = "input", position = {0, 1.5}},
			},
		},
		burns_fluid = true,
		scale_fluid_usage = true,
		effectivity = 1,
		emissions_per_minute = 30,
		smoke = {{
				name = "smoke",
				north_position = util.by_pixel(-38, -47.5),
				south_position = util.by_pixel(38.5, -32),
				east_position = util.by_pixel(20, -70),
				west_position = util.by_pixel(-19, -8.5),
				frequency = 15,
				starting_vertical_speed = 0.3,
				starting_frame_deviation = 0
		}},
		light_flicker = {
			color = {r=1,g=0.5,b=0.5,a=0.5},
			minimum_light_size = 0.1,
			light_intensity_to_size_coefficient = 1
		}
	}
	gf_boiler_entity.fire_flicker_enabled = false
	gf_boiler_entity.fire_glow_flicker_enabled = false
	gf_boiler_entity.fire = {}
	gf_boiler_entity.fire_glow.north.filename = 
		"__adamo-cinefaction__/graphics/entity/"..
		"gf-boiler-N-light.png"
	gf_boiler_entity.fire_glow.south.filename = 
		"__adamo-cinefaction__/graphics/entity/"..
		"gf-boiler-S-light.png"
	gf_boiler_entity.fire_glow.east.filename = 
		"__adamo-cinefaction__/graphics/entity/"..
		"gf-boiler-E-light.png"
	gf_boiler_entity.fire_glow.west.filename = 
		"__adamo-cinefaction__/graphics/entity/"..
		"gf-boiler-W-light.png"
	gf_boiler_entity.fire_glow.north.hr_version.filename = 
		"__adamo-cinefaction__/graphics/entity/"..
		"hr-gf-boiler-N-light.png"
	gf_boiler_entity.fire_glow.south.hr_version.filename = 
		"__adamo-cinefaction__/graphics/entity/"..
		"hr-gf-boiler-S-light.png"
	gf_boiler_entity.fire_glow.east.hr_version.filename = 
		"__adamo-cinefaction__/graphics/entity/"..
		"hr-gf-boiler-E-light.png"
	gf_boiler_entity.fire_glow.west.hr_version.filename = 
		"__adamo-cinefaction__/graphics/entity/"..
		"hr-gf-boiler-W-light.png"
	gf_boiler_entity.fire_glow.north.apply_runtime_tint = true
	gf_boiler_entity.fire_glow.south.apply_runtime_tint = true
	gf_boiler_entity.fire_glow.east.apply_runtime_tint = true
	gf_boiler_entity.fire_glow.west.apply_runtime_tint = true
	gf_boiler_entity.fire_glow.north.tint={r=1,g=0.6,b=0.6,a=0.4}
	gf_boiler_entity.fire_glow.south.tint={r=1,g=0.6,b=0.6,a=0.4}
	gf_boiler_entity.fire_glow.east.tint={r=1,g=0.6,b=0.6,a=0.4}
	gf_boiler_entity.fire_glow.west.tint={r=1,g=0.6,b=0.6,a=0.4}
	gf_boiler_entity.fire_glow.north.blend_mode = "additive-soft"
	gf_boiler_entity.fire_glow.south.blend_mode = "additive-soft"
	gf_boiler_entity.fire_glow.east.blend_mode = "additive-soft"
	gf_boiler_entity.fire_glow.west.blend_mode = "additive-soft"
	
	
	gf_boiler_item = util.table.deepcopy(data.raw.item.boiler)
	gf_boiler_item.name = "adamo-cinefaction-gas-fired-boiler"
	gf_boiler_item.icon_size = 32
	gf_boiler_item.icon = "__adamo-cinefaction__/graphics/icons/gas-fired-boiler.png"
	gf_boiler_item.order = "b[steam-power]-b[adamo-cinefaction-gas-fired-boiler]"
	gf_boiler_item.place_result = "adamo-cinefaction-gas-fired-boiler"
	
	gf_boiler_recipe = {
		type = "recipe",
		name = "adamo-cinefaction-gas-fired-boiler",
		enabled = false,
		ingredients = {{
				"stone-brick",5
			},{
				"pipe",5
			},{
				"pump",1
		}},
		result = "adamo-cinefaction-gas-fired-boiler"
	}

	data:extend({
		gf_boiler_item,
		gf_boiler_recipe,
		gf_boiler_entity
	})
end